
  (* Lexical analyzer for Test evaluator
     Author C.P.Osborne
     Modified:
	25/09/2000	CPO	Created
  *)

L				[A-Za-z]
D				[0-9]

%%

  var result : integer;

{D}+(\.{D}+)?([Ee][+-]?{D}+)?	begin
				  val(yytext, yylval.yyReal, result);
				  if result=0 then
				    return(NUMC)
				  else
				    return(ILLEGAL)
				end;

{L}\!				begin
				  yylval.yyInteger := ord(upCase(yytext[1]))-
						      ord('A')+1;
				  return(BID)
				end;

{L}\$				begin
				  yylval.yyInteger := ord(upCase(yytext[1]))-
						      ord('A')+1;
				  return(SID)
				end;

{L}				begin
				  yylval.yyInteger := ord(upCase(yytext[1]))-
						      ord('A')+1;
				  return(RID)
				end;

\'[^\'\n]*\'			begin
				  yylval.yyString  := Copy( yytext, 2, Length(yytext)-2);
				  return(STRC)
				end;

{[^}\n]*}			;

[aA][bB][sS]			return(RABS);
[aA][nN][dD]			return(BAND);
[nN][oO][tT]			return(BNOT);
[oO][rR]			return(BOR);
[iI][fF]			return(BIF);
[tT][hH][eE][nN]		return(BTHEN);
[eE][lL][sS][eE]		return(BELSE);
[eE][nN][dD][iI][fF]		return(BENDIF);
[iI][nN]			return(BIN);
:=				return(TASSIGN);
>=				return(GE);
\<=				return(LE);
\<>				return(NE);

" "             		;

.				|
\n				returnc(yytext[1]);
