{ lexical analyzer template (TP Lex V3.0), V1.0 3-2-91 AG		}
{ 24.3.98: repacked into an class to make code thread-safe.		}
{ Modified September 2000 by C.P.Osborne for Delphi 4/5			}
{	11/09/2000	CPO	Mods started.				}
{				Converted for new LexLib, YaccLib.	}

{ global definitions: 							}

  (* Lexical analyzer for Test evaluator
     Author C.P.Osborne
     Modified:
	25/09/2000	CPO	Created
  *)



function TLex.yylex(var yylval: YYSType): Integer;

procedure yyaction ( yyruleno : Integer );

{ local definitions:							}

  var result : integer;

begin
  { actions: 								}
  case yyruleno of
  1:
                             	begin
				  val(yytext, yylval.yyReal, result);
				  if result=0 then
				    return(NUMC)
				  else
				    return(ILLEGAL)
				end;

  2:
     				begin
				  yylval.yyInteger := ord(upCase(yytext[1]))-
						      ord('A')+1;
				  return(BID)
				end;

  3:
     				begin
				  yylval.yyInteger := ord(upCase(yytext[1]))-
						      ord('A')+1;
				  return(SID)
				end;

  4:
   				begin
				  yylval.yyInteger := ord(upCase(yytext[1]))-
						      ord('A')+1;
				  return(RID)
				end;

  5:
            			begin
				  yylval.yyString  := Copy( yytext, 2, Length(yytext)-2);
				  return(STRC)
				end;

  6:
         			;

  7:
            			return(RABS);
  8:
            			return(BAND);
  9:
            			return(BNOT);
  10:
        			return(BOR);
  11:
        			return(BIF);
  12:
                		return(BTHEN);
  13:
                		return(BELSE);
  14:
                    		return(BENDIF);
  15:
        			return(BIN);
  16:
  				return(TASSIGN);
  17:
  				return(GE);
  18:
   				return(LE);
  19:
   				return(NE);

  20:
                		;

  21,
  22:
  				returnc(yytext[1]);
  end;
end;	{ yyaction	}

{ DFA table: 								}

type YYTRec = record
                cc : set of Char;
                s  : Integer;
              end;

const

yynmarks   = 45;
yynmatches = 45;
yyntrans   = 90;
yynstates  = 53;

yyk : array [1..yynmarks] of Integer = (
  { 0: }
  { 1: }
  { 2: }
  1,
  21,
  { 3: }
  4,
  21,
  { 4: }
  21,
  { 5: }
  21,
  { 6: }
  4,
  21,
  { 7: }
  4,
  21,
  { 8: }
  4,
  21,
  { 9: }
  4,
  21,
  { 10: }
  4,
  21,
  { 11: }
  4,
  21,
  { 12: }
  21,
  { 13: }
  21,
  { 14: }
  21,
  { 15: }
  20,
  21,
  { 16: }
  21,
  { 17: }
  22,
  { 18: }
  1,
  { 19: }
  { 20: }
  { 21: }
  2,
  { 22: }
  3,
  { 23: }
  { 24: }
  5,
  { 25: }
  { 26: }
  6,
  { 27: }
  { 28: }
  { 29: }
  { 30: }
  10,
  { 31: }
  11,
  { 32: }
  15,
  { 33: }
  { 34: }
  { 35: }
  { 36: }
  16,
  { 37: }
  17,
  { 38: }
  18,
  { 39: }
  19,
  { 40: }
  1,
  { 41: }
  { 42: }
  1,
  { 43: }
  7,
  { 44: }
  8,
  { 45: }
  9,
  { 46: }
  { 47: }
  { 48: }
  { 49: }
  12,
  { 50: }
  13,
  { 51: }
  { 52: }
  14
);

yym : array [1..yynmatches] of Integer = (
{ 0: }
{ 1: }
{ 2: }
  1,
  21,
{ 3: }
  4,
  21,
{ 4: }
  21,
{ 5: }
  21,
{ 6: }
  4,
  21,
{ 7: }
  4,
  21,
{ 8: }
  4,
  21,
{ 9: }
  4,
  21,
{ 10: }
  4,
  21,
{ 11: }
  4,
  21,
{ 12: }
  21,
{ 13: }
  21,
{ 14: }
  21,
{ 15: }
  20,
  21,
{ 16: }
  21,
{ 17: }
  22,
{ 18: }
  1,
{ 19: }
{ 20: }
{ 21: }
  2,
{ 22: }
  3,
{ 23: }
{ 24: }
  5,
{ 25: }
{ 26: }
  6,
{ 27: }
{ 28: }
{ 29: }
{ 30: }
  10,
{ 31: }
  11,
{ 32: }
  15,
{ 33: }
{ 34: }
{ 35: }
{ 36: }
  16,
{ 37: }
  17,
{ 38: }
  18,
{ 39: }
  19,
{ 40: }
  1,
{ 41: }
{ 42: }
  1,
{ 43: }
  7,
{ 44: }
  8,
{ 45: }
  9,
{ 46: }
{ 47: }
{ 48: }
{ 49: }
  12,
{ 50: }
  13,
{ 51: }
{ 52: }
  14
);

yyt : array [1..yyntrans] of YYTrec = (
{ 0: }
  ( cc: [ #1..#9,#11..#31,'!'..'&','('..'/',';','=',
            '?','@','['..'`','|'..#255 ]; s: 16),
  ( cc: [ #10 ]; s: 17),
  ( cc: [ ' ' ]; s: 15),
  ( cc: [ '''' ]; s: 4),
  ( cc: [ '0'..'9' ]; s: 2),
  ( cc: [ ':' ]; s: 12),
  ( cc: [ '<' ]; s: 14),
  ( cc: [ '>' ]; s: 13),
  ( cc: [ 'A','a' ]; s: 6),
  ( cc: [ 'B'..'D','F'..'H','J'..'M','P'..'S','U'..'Z',
            'b'..'d','f'..'h','j'..'m','p'..'s','u'..'z' ]; s: 3),
  ( cc: [ 'E','e' ]; s: 11),
  ( cc: [ 'I','i' ]; s: 9),
  ( cc: [ 'N','n' ]; s: 7),
  ( cc: [ 'O','o' ]; s: 8),
  ( cc: [ 'T','t' ]; s: 10),
  ( cc: [ '{' ]; s: 5),
{ 1: }
  ( cc: [ #1..#9,#11..#31,'!'..'&','('..'/',';','=',
            '?','@','['..'`','|'..#255 ]; s: 16),
  ( cc: [ #10 ]; s: 17),
  ( cc: [ ' ' ]; s: 15),
  ( cc: [ '''' ]; s: 4),
  ( cc: [ '0'..'9' ]; s: 2),
  ( cc: [ ':' ]; s: 12),
  ( cc: [ '<' ]; s: 14),
  ( cc: [ '>' ]; s: 13),
  ( cc: [ 'A','a' ]; s: 6),
  ( cc: [ 'B'..'D','F'..'H','J'..'M','P'..'S','U'..'Z',
            'b'..'d','f'..'h','j'..'m','p'..'s','u'..'z' ]; s: 3),
  ( cc: [ 'E','e' ]; s: 11),
  ( cc: [ 'I','i' ]; s: 9),
  ( cc: [ 'N','n' ]; s: 7),
  ( cc: [ 'O','o' ]; s: 8),
  ( cc: [ 'T','t' ]; s: 10),
  ( cc: [ '{' ]; s: 5),
{ 2: }
  ( cc: [ '.' ]; s: 19),
  ( cc: [ '0'..'9' ]; s: 18),
  ( cc: [ 'E','e' ]; s: 20),
{ 3: }
  ( cc: [ '!' ]; s: 21),
  ( cc: [ '$' ]; s: 22),
{ 4: }
  ( cc: [ #1..#9,#11..'&','('..#255 ]; s: 23),
  ( cc: [ '''' ]; s: 24),
{ 5: }
  ( cc: [ #1..#9,#11..'|','~'..#255 ]; s: 25),
  ( cc: [ '}' ]; s: 26),
{ 6: }
  ( cc: [ '!' ]; s: 21),
  ( cc: [ '$' ]; s: 22),
  ( cc: [ 'B','b' ]; s: 27),
  ( cc: [ 'N','n' ]; s: 28),
{ 7: }
  ( cc: [ '!' ]; s: 21),
  ( cc: [ '$' ]; s: 22),
  ( cc: [ 'O','o' ]; s: 29),
{ 8: }
  ( cc: [ '!' ]; s: 21),
  ( cc: [ '$' ]; s: 22),
  ( cc: [ 'R','r' ]; s: 30),
{ 9: }
  ( cc: [ '!' ]; s: 21),
  ( cc: [ '$' ]; s: 22),
  ( cc: [ 'F','f' ]; s: 31),
  ( cc: [ 'N','n' ]; s: 32),
{ 10: }
  ( cc: [ '!' ]; s: 21),
  ( cc: [ '$' ]; s: 22),
  ( cc: [ 'H','h' ]; s: 33),
{ 11: }
  ( cc: [ '!' ]; s: 21),
  ( cc: [ '$' ]; s: 22),
  ( cc: [ 'L','l' ]; s: 34),
  ( cc: [ 'N','n' ]; s: 35),
{ 12: }
  ( cc: [ '=' ]; s: 36),
{ 13: }
  ( cc: [ '=' ]; s: 37),
{ 14: }
  ( cc: [ '=' ]; s: 38),
  ( cc: [ '>' ]; s: 39),
{ 15: }
{ 16: }
{ 17: }
{ 18: }
  ( cc: [ '.' ]; s: 19),
  ( cc: [ '0'..'9' ]; s: 18),
  ( cc: [ 'E','e' ]; s: 20),
{ 19: }
  ( cc: [ '0'..'9' ]; s: 40),
{ 20: }
  ( cc: [ '+','-' ]; s: 41),
  ( cc: [ '0'..'9' ]; s: 42),
{ 21: }
{ 22: }
{ 23: }
  ( cc: [ #1..#9,#11..'&','('..#255 ]; s: 23),
  ( cc: [ '''' ]; s: 24),
{ 24: }
{ 25: }
  ( cc: [ #1..#9,#11..'|','~'..#255 ]; s: 25),
  ( cc: [ '}' ]; s: 26),
{ 26: }
{ 27: }
  ( cc: [ 'S','s' ]; s: 43),
{ 28: }
  ( cc: [ 'D','d' ]; s: 44),
{ 29: }
  ( cc: [ 'T','t' ]; s: 45),
{ 30: }
{ 31: }
{ 32: }
{ 33: }
  ( cc: [ 'E','e' ]; s: 46),
{ 34: }
  ( cc: [ 'S','s' ]; s: 47),
{ 35: }
  ( cc: [ 'D','d' ]; s: 48),
{ 36: }
{ 37: }
{ 38: }
{ 39: }
{ 40: }
  ( cc: [ '0'..'9' ]; s: 40),
  ( cc: [ 'E','e' ]; s: 20),
{ 41: }
  ( cc: [ '0'..'9' ]; s: 42),
{ 42: }
  ( cc: [ '0'..'9' ]; s: 42),
{ 43: }
{ 44: }
{ 45: }
{ 46: }
  ( cc: [ 'N','n' ]; s: 49),
{ 47: }
  ( cc: [ 'E','e' ]; s: 50),
{ 48: }
  ( cc: [ 'I','i' ]; s: 51),
{ 49: }
{ 50: }
{ 51: }
  ( cc: [ 'F','f' ]; s: 52)
{ 52: }
);

yykl : array [0..yynstates-1] of Integer = (
{ 0: } 1,
{ 1: } 1,
{ 2: } 1,
{ 3: } 3,
{ 4: } 5,
{ 5: } 6,
{ 6: } 7,
{ 7: } 9,
{ 8: } 11,
{ 9: } 13,
{ 10: } 15,
{ 11: } 17,
{ 12: } 19,
{ 13: } 20,
{ 14: } 21,
{ 15: } 22,
{ 16: } 24,
{ 17: } 25,
{ 18: } 26,
{ 19: } 27,
{ 20: } 27,
{ 21: } 27,
{ 22: } 28,
{ 23: } 29,
{ 24: } 29,
{ 25: } 30,
{ 26: } 30,
{ 27: } 31,
{ 28: } 31,
{ 29: } 31,
{ 30: } 31,
{ 31: } 32,
{ 32: } 33,
{ 33: } 34,
{ 34: } 34,
{ 35: } 34,
{ 36: } 34,
{ 37: } 35,
{ 38: } 36,
{ 39: } 37,
{ 40: } 38,
{ 41: } 39,
{ 42: } 39,
{ 43: } 40,
{ 44: } 41,
{ 45: } 42,
{ 46: } 43,
{ 47: } 43,
{ 48: } 43,
{ 49: } 43,
{ 50: } 44,
{ 51: } 45,
{ 52: } 45
);

yykh : array [0..yynstates-1] of Integer = (
{ 0: } 0,
{ 1: } 0,
{ 2: } 2,
{ 3: } 4,
{ 4: } 5,
{ 5: } 6,
{ 6: } 8,
{ 7: } 10,
{ 8: } 12,
{ 9: } 14,
{ 10: } 16,
{ 11: } 18,
{ 12: } 19,
{ 13: } 20,
{ 14: } 21,
{ 15: } 23,
{ 16: } 24,
{ 17: } 25,
{ 18: } 26,
{ 19: } 26,
{ 20: } 26,
{ 21: } 27,
{ 22: } 28,
{ 23: } 28,
{ 24: } 29,
{ 25: } 29,
{ 26: } 30,
{ 27: } 30,
{ 28: } 30,
{ 29: } 30,
{ 30: } 31,
{ 31: } 32,
{ 32: } 33,
{ 33: } 33,
{ 34: } 33,
{ 35: } 33,
{ 36: } 34,
{ 37: } 35,
{ 38: } 36,
{ 39: } 37,
{ 40: } 38,
{ 41: } 38,
{ 42: } 39,
{ 43: } 40,
{ 44: } 41,
{ 45: } 42,
{ 46: } 42,
{ 47: } 42,
{ 48: } 42,
{ 49: } 43,
{ 50: } 44,
{ 51: } 44,
{ 52: } 45
);

yyml : array [0..yynstates-1] of Integer = (
{ 0: } 1,
{ 1: } 1,
{ 2: } 1,
{ 3: } 3,
{ 4: } 5,
{ 5: } 6,
{ 6: } 7,
{ 7: } 9,
{ 8: } 11,
{ 9: } 13,
{ 10: } 15,
{ 11: } 17,
{ 12: } 19,
{ 13: } 20,
{ 14: } 21,
{ 15: } 22,
{ 16: } 24,
{ 17: } 25,
{ 18: } 26,
{ 19: } 27,
{ 20: } 27,
{ 21: } 27,
{ 22: } 28,
{ 23: } 29,
{ 24: } 29,
{ 25: } 30,
{ 26: } 30,
{ 27: } 31,
{ 28: } 31,
{ 29: } 31,
{ 30: } 31,
{ 31: } 32,
{ 32: } 33,
{ 33: } 34,
{ 34: } 34,
{ 35: } 34,
{ 36: } 34,
{ 37: } 35,
{ 38: } 36,
{ 39: } 37,
{ 40: } 38,
{ 41: } 39,
{ 42: } 39,
{ 43: } 40,
{ 44: } 41,
{ 45: } 42,
{ 46: } 43,
{ 47: } 43,
{ 48: } 43,
{ 49: } 43,
{ 50: } 44,
{ 51: } 45,
{ 52: } 45
);

yymh : array [0..yynstates-1] of Integer = (
{ 0: } 0,
{ 1: } 0,
{ 2: } 2,
{ 3: } 4,
{ 4: } 5,
{ 5: } 6,
{ 6: } 8,
{ 7: } 10,
{ 8: } 12,
{ 9: } 14,
{ 10: } 16,
{ 11: } 18,
{ 12: } 19,
{ 13: } 20,
{ 14: } 21,
{ 15: } 23,
{ 16: } 24,
{ 17: } 25,
{ 18: } 26,
{ 19: } 26,
{ 20: } 26,
{ 21: } 27,
{ 22: } 28,
{ 23: } 28,
{ 24: } 29,
{ 25: } 29,
{ 26: } 30,
{ 27: } 30,
{ 28: } 30,
{ 29: } 30,
{ 30: } 31,
{ 31: } 32,
{ 32: } 33,
{ 33: } 33,
{ 34: } 33,
{ 35: } 33,
{ 36: } 34,
{ 37: } 35,
{ 38: } 36,
{ 39: } 37,
{ 40: } 38,
{ 41: } 38,
{ 42: } 39,
{ 43: } 40,
{ 44: } 41,
{ 45: } 42,
{ 46: } 42,
{ 47: } 42,
{ 48: } 42,
{ 49: } 43,
{ 50: } 44,
{ 51: } 44,
{ 52: } 45
);

yytl : array [0..yynstates-1] of Integer = (
{ 0: } 1,
{ 1: } 17,
{ 2: } 33,
{ 3: } 36,
{ 4: } 38,
{ 5: } 40,
{ 6: } 42,
{ 7: } 46,
{ 8: } 49,
{ 9: } 52,
{ 10: } 56,
{ 11: } 59,
{ 12: } 63,
{ 13: } 64,
{ 14: } 65,
{ 15: } 67,
{ 16: } 67,
{ 17: } 67,
{ 18: } 67,
{ 19: } 70,
{ 20: } 71,
{ 21: } 73,
{ 22: } 73,
{ 23: } 73,
{ 24: } 75,
{ 25: } 75,
{ 26: } 77,
{ 27: } 77,
{ 28: } 78,
{ 29: } 79,
{ 30: } 80,
{ 31: } 80,
{ 32: } 80,
{ 33: } 80,
{ 34: } 81,
{ 35: } 82,
{ 36: } 83,
{ 37: } 83,
{ 38: } 83,
{ 39: } 83,
{ 40: } 83,
{ 41: } 85,
{ 42: } 86,
{ 43: } 87,
{ 44: } 87,
{ 45: } 87,
{ 46: } 87,
{ 47: } 88,
{ 48: } 89,
{ 49: } 90,
{ 50: } 90,
{ 51: } 90,
{ 52: } 91
);

yyth : array [0..yynstates-1] of Integer = (
{ 0: } 16,
{ 1: } 32,
{ 2: } 35,
{ 3: } 37,
{ 4: } 39,
{ 5: } 41,
{ 6: } 45,
{ 7: } 48,
{ 8: } 51,
{ 9: } 55,
{ 10: } 58,
{ 11: } 62,
{ 12: } 63,
{ 13: } 64,
{ 14: } 66,
{ 15: } 66,
{ 16: } 66,
{ 17: } 66,
{ 18: } 69,
{ 19: } 70,
{ 20: } 72,
{ 21: } 72,
{ 22: } 72,
{ 23: } 74,
{ 24: } 74,
{ 25: } 76,
{ 26: } 76,
{ 27: } 77,
{ 28: } 78,
{ 29: } 79,
{ 30: } 79,
{ 31: } 79,
{ 32: } 79,
{ 33: } 80,
{ 34: } 81,
{ 35: } 82,
{ 36: } 82,
{ 37: } 82,
{ 38: } 82,
{ 39: } 82,
{ 40: } 84,
{ 41: } 85,
{ 42: } 86,
{ 43: } 86,
{ 44: } 86,
{ 45: } 86,
{ 46: } 87,
{ 47: } 88,
{ 48: } 89,
{ 49: } 89,
{ 50: } 89,
{ 51: } 90,
{ 52: } 90
);


var yyn : Integer;

label start, scan, action;

begin
start:
  { initialize:								}

  yynew;

scan:

  { Mark positions and matches: 					}

  for yyn := yykl[yystate] to     yykh[yystate] do yymark(yyk[yyn]);
  for yyn := yymh[yystate] downto yyml[yystate] do yymatch(yym[yyn]);

  if yytl[yystate]>yyth[yystate] then goto action;	{ dead state	}

  { Get next character:							}

  yyscan;

  { Determine action:							}

  yyn := yytl[yystate];
  while (yyn<=yyth[yystate]) and not (yyactchar in yyt[yyn].cc) do inc(yyn);
  if yyn>yyth[yystate] then goto action;
	{ No transition on yyactchar in this state.			}

  { Switch to new state:						}

  yystate := yyt[yyn].s;

  goto scan;

action:

  { Execute action: 							}

  if yyfind(yyrule) then
    begin
      yyaction(yyrule);
      if yyreject then goto action;
    end
  else if not yydefault and yywrap then
    begin
      yyclear;
      return(0);
    end;

  if not yydone then goto start;

  yylex := yyretval;
end;	{ yylex	}

